#include <detect/detect.h>
#include <detect/i386.h>
#include <detect/i386_cpuid.h> /* Private Header */

void cpu_detector(){
	static unsigned int reg[4];

	cpuid_func(CPUID_VENDORID,reg);
	if(reg[EAX]<CPUID_PROCINFO) return;

	cpuid_func(CPUID_PROCINFO,reg);
	if(reg[EDX]&CPU_EDX_MMX)    cpu_flags|=CPU_MMX;
	if(reg[EDX]&CPU_EDX_SSE)    cpu_flags|=CPU_SSE;
	if(reg[EDX]&CPU_EDX_SSE2)   cpu_flags|=CPU_SSE2;
	if(reg[EDX]&CPU_EDX_FXSAVE) cpu_flags|=CPU_FXSAVE;
	if(reg[EDX]&CPU_EDX_CMOV)   cpu_flags|=CPU_CMOV;
	if(reg[EDX]&CPU_EDX_HT)     cpu_flags|=CPU_HT;
	if(reg[EDX]&CPU_EDX_CX8B)   cpu_flags|=CPU_CX8B;
	if(reg[ECX]&CPU_ECX_SSE3)   cpu_flags|=CPU_SSE3;
	if(reg[ECX]&CPU_ECX_SSSE3)  cpu_flags|=CPU_SSSE3;
	if(reg[ECX]&CPU_ECX_SSE41)  cpu_flags|=CPU_SSE41;
	if(reg[ECX]&CPU_ECX_SSE42)  cpu_flags|=CPU_SSE42;
	if(reg[ECX]&CPU_ECX_CX16B)  cpu_flags|=CPU_CX16B;
	if(reg[ECX]&CPU_ECX_POPCNT) cpu_flags|=CPU_POPCNT;

	cpuid_func(CPUID_HEXTFUNC,reg);
	if(reg[EAX]<CPUID_EPROINFO) return;

	cpuid_func(CPUID_EPROINFO,reg);
	if(reg[EDX]&CPU_EDX_AMDMMX) cpu_flags|=CPU_AMDMMX;
	if(reg[EDX]&CPU_EDX_3DN)    cpu_flags|=CPU_3DN;
	if(reg[EDX]&CPU_EDX_E3DN)   cpu_flags|=CPU_E3DN;
	if(reg[EDX]&CPU_EDX_LM)     cpu_flags|=CPU_LM;
	if(reg[ECX]&CPU_ECX_SSE4A)  cpu_flags|=CPU_SSE4A;
	if(reg[ECX]&CPU_ECX_SSE5A)  cpu_flags|=CPU_SSE5A;
	if(reg[ECX]&CPU_ECX_LAHF_LM)cpu_flags|=CPU_LAHF_LM;
}
